type encoding = [ `CHARSET of string | `LOCALE | `NONE ]

type t

type callback = 
  exceptions:exn list -> 
  stdout:string -> 
  stderr:string -> 
  int -> unit

val spawn_out :
  encoding:encoding ->
  cmd:string list -> 
  reap_callback:(unit -> unit) ->
  callback -> t

val spawn_inout :
  encoding:encoding ->
  cmd:string list ->
  input:string -> 
  reap_callback:(unit -> unit) ->
  callback -> t

val abort : t -> unit
